3 # Rewrite revision history
4 # Copyright (c) Petr Baudis, 2006
5 # Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
7 # Lets you rewrite the revision history of the current branch, creating
8 # a new branch. You can specify a number of filters to modify the commits,
11 # The following functions will also be available in the commit filter:
13 functions
=$
(cat << \EOF
20 # if it was not rewritten, take the original
21 if test -r "$workdir/../map/$1"
23 cat "$workdir/../map/$1"
29 # if you run 'skip_commit "$@"' in a commit filter, it will print
30 # the (mapped) parents, effectively skipping the commit.
43 # if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
44 # it will skip commits that leave the tree untouched, commit the other.
45 git_commit_non_empty_tree
()
47 if test $# = 3 && test "$1" = $
(git rev-parse
"$3^{tree}"); then
53 # override die(): this version puts in an extra line break, so that
54 # the progress is still visible
67 # When piped a commit, output a script to set the ident of either
68 # "author" or "committer
71 lid
="$(echo "$1" | tr "[A-Z
]" "[a-z
]")"
72 uid
="$(echo "$1" | tr "[a-z
]" "[A-Z
]")"
77 s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
79 s
/.
*/GIT_
'$uid'_NAME
='\''&'\''; export GIT_
'$uid'_NAME
/p
82 s
/^
'$lid' [^
<]* <\
([^
>]*\
)> .
*$
/\
1/
84 s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
87 s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
89 s
/.
*/GIT_
'$uid'_DATE
='\''&'\''; export GIT_
'$uid'_DATE
/p
95 LANG=C LC_ALL=C sed -ne "$pick_id_script"
96 # Ensure non-empty id name.
97 echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
100 USAGE="[--env-filter <command>] [--tree-filter <command>]
101 [--index-filter <command>] [--parent-filter <command>]
102 [--msg-filter <command>] [--commit-filter <command>]
103 [--tag-name-filter <command>] [--subdirectory-filter <directory>]
104 [--original <namespace>] [-d <directory>] [-f | --force]
105 [<rev-list options>...]"
110 if [ "$(is_bare_repository)" = false ]; then
111 git diff-files --ignore-submodules --quiet &&
112 git diff-index --cached --quiet HEAD -- ||
113 die "Cannot rewrite branch(es) with a dirty working directory."
125 orig_namespace=refs/original/
157 # all switches take one argument
159 case "$#" in 1) usage ;; esac
172 filter_tree="$OPTARG"
175 filter_index="$OPTARG"
178 filter_parent="$OPTARG"
184 filter_commit="$functions; $OPTARG"
187 filter_tag_name="$OPTARG"
189 --subdirectory-filter)
190 filter_subdir="$OPTARG"
194 orig_namespace=$(expr "$OPTARG/" : '\
(.
*[^
/]\
)/*$
')/
202 case "$prune_empty,$filter_commit" in
204 filter_commit='git commit-tree
"$@"';;
206 filter_commit="$functions;"' git_commit_non_empty_tree
"$@"';;
210 die "Cannot set --prune-empty and --commit-filter at the same time"
218 test -d "$tempdir" &&
219 die "$tempdir already exists, please remove it"
221 mkdir -p "$tempdir/t" &&
222 tempdir="$(cd "$tempdir"; pwd)" &&
227 # Remove tempdir on exit
228 trap 'cd ..
/..
; rm -rf "$tempdir"' 0
230 ORIG_GIT_DIR="$GIT_DIR"
231 ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
232 ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
234 export GIT_DIR GIT_WORK_TREE
236 # Make sure refs/original is empty
237 git for-each-ref > "$tempdir"/backup-refs || exit
238 while read sha1 type name
240 case "$force,$name" in
242 die "Cannot create a new backup.
243 A previous backup already exists in $orig_namespace
244 Force overwriting the backup with -f"
247 git update-ref -d "$name" $sha1
250 done < "$tempdir"/backup-refs
252 # The refs should be updated if their heads were rewritten
253 git rev-parse --no-flags --revs-only --symbolic-full-name \
254 --default HEAD "$@" > "$tempdir"/raw-heads || exit
255 sed -e '/^^
/d
' "$tempdir"/raw-heads >"$tempdir"/heads
257 test -s "$tempdir"/heads ||
258 die "Which ref do you want to rewrite?"
260 GIT_INDEX_FILE="$(pwd)/../index"
261 export GIT_INDEX_FILE
263 # map old->new commit ids for rewriting parents
264 mkdir ../map || die "Could not create map/ directory"
266 # we need "--" only if there are no path arguments in $@
267 nonrevs=$(git rev-parse --no-revs "$@") || exit
268 test -z "$nonrevs" && dashdash=-- || dashdash=
269 rev_args=$(git rev-parse --revs-only "$@")
271 case "$filter_subdir" in
273 eval set -- "$(git rev-parse --sq --no-revs "$@")"
276 eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
281 git rev-list --reverse --topo-order --default HEAD \
282 --parents --simplify-merges $rev_args "$@" > ../revs ||
283 die "Could not get the commits"
284 commits=$(wc -l <../revs | tr -d " ")
286 test $commits -eq 0 && die "Found nothing to rewrite"
288 # Rewrite the commits
290 git_filter_branch__commit_count=0
291 while read commit parents; do
292 git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
293 printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
295 case "$filter_subdir" in
297 git read-tree -i -m $commit
300 # The commit may not have the subdirectory at all
301 err=$(git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
302 if ! git rev-parse -q --verify $commit:"$filter_subdir"
304 rm -f "$GIT_INDEX_FILE"
310 esac || die "Could not initialize the index"
314 git cat-file commit "$commit" >../commit ||
315 die "Cannot read commit $commit"
317 eval "$(set_ident AUTHOR <../commit)" ||
318 die "setting author failed for commit $commit"
319 eval "$(set_ident COMMITTER <../commit)" ||
320 die "setting committer failed for commit $commit"
321 eval "$filter_env" < /dev/null ||
322 die "env filter failed: $filter_env"
324 if [ "$filter_tree" ]; then
325 git checkout-index -f -u -a ||
326 die "Could not checkout the index"
327 # files that $commit removed are now still in the working tree;
328 # remove them, else they would be added again
329 git clean -d -q -f -x
330 eval "$filter_tree" < /dev/null ||
331 die "tree filter failed: $filter_tree"
334 git diff-index -r --name-only --ignore-submodules $commit &&
335 git ls-files --others
336 ) > "$tempdir"/tree-state || exit
337 git update-index --add --replace --remove --stdin \
338 < "$tempdir"/tree-state || exit
341 eval "$filter_index" < /dev/null ||
342 die "index filter failed: $filter_index"
345 for parent in $parents; do
346 for reparent in $(map "$parent"); do
347 parentstr="$parentstr -p $reparent"
350 if [ "$filter_parent" ]; then
351 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
352 die "parent filter failed: $filter_parent"
355 sed -e '1,/^$
/d
' <../commit | \
356 eval "$filter_msg" > ../message ||
357 die "msg filter failed: $filter_msg"
358 @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
359 $(git write-tree) $parentstr < ../message > ../map/$commit ||
360 die "could not write rewritten commit"
363 # If we are filtering for paths, as in the case of a subdirectory
364 # filter, it is possible that a specified head is not in the set of
365 # rewritten commits, because it was pruned by the revision walker.
366 # Ancestor remapping fixes this by mapping these heads to the unique
367 # nearest ancestor that survived the pruning.
369 if test "$remap_to_ancestor" = t
373 sha1=$(git rev-parse "$ref"^0)
374 test -f "$workdir"/../map/$sha1 && continue
375 ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
376 test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
377 done < "$tempdir"/heads
380 # Finally update the refs
382 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
383 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
387 # avoid rewriting a ref twice
388 test -f "$orig_namespace$ref" && continue
390 sha1=$(git rev-parse "$ref"^0)
391 rewritten=$(map $sha1)
393 test $sha1 = "$rewritten" &&
394 warn "WARNING: Ref '$ref' is unchanged" &&
399 echo "Ref '$ref' was deleted"
400 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
401 die "Could not delete $ref"
404 echo "Ref '$ref' was rewritten"
405 if ! git update-ref -m "filter-branch: rewrite" \
406 "$ref" $rewritten $sha1 2>/dev/null; then
407 if test $(git cat-file -t "$ref") = tag; then
408 if test -z "$filter_tag_name"; then
409 warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
410 warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
413 die "Could not rewrite $ref"
418 # NEEDSWORK: possibly add -Werror, making this an error
419 warn "WARNING: '$ref' was rewritten into multiple commits:"
421 warn "WARNING: Ref '$ref' points to the first one now."
422 rewritten=$(echo "$rewritten" | head -n 1)
423 git update-ref -m "filter-branch: rewrite to first" \
424 "$ref" $rewritten $sha1 ||
425 die "Could not rewrite $ref"
428 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
430 done < "$tempdir"/heads
432 # TODO: This should possibly go, with the semantics that all positive given
433 # refs are updated, and their original heads stored in refs/original/
436 if [ "$filter_tag_name" ]; then
437 git for-each-ref --format='%(objectname
) %(objecttype
) %(refname
)' refs/tags |
438 while read sha1 type ref; do
439 ref="${ref#refs/tags/}"
440 # XXX: Rewrite tagged trees as well?
441 if [ "$type" != "commit" -a "$type" != "tag" ]; then
445 if [ "$type" = "tag" ]; then
446 # Dereference to a commit
448 sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
451 [ -f "../map/$sha1" ] || continue
452 new_sha1="$(cat "../map/$sha1")"
455 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
456 die "tag name filter failed: $filter_tag_name"
458 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
460 if [ "$type" = "tag" ]; then
461 new_sha1=$( ( printf 'object
%s
\ntype commit
\ntag
%s
\n' \
462 "$new_sha1" "$new_ref"
463 git cat-file tag "$ref" |
470 -e '/^
-----BEGIN PGP SIGNATURE----
-/q
' \
473 die "Could not create new tag object for $ref"
474 if git cat-file tag "$ref" | \
475 sane_grep '^
-----BEGIN PGP SIGNATURE-----
' >/dev/null 2>&1
477 warn "gpg signature stripped from tag object $sha1t"
481 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
482 die "Could not write tag $new_ref"
491 unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
492 test -z "$ORIG_GIT_DIR" || {
493 GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
495 test -z "$ORIG_GIT_WORK_TREE" || {
496 GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
499 test -z "$ORIG_GIT_INDEX_FILE" || {
500 GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
501 export GIT_INDEX_FILE
504 if [ "$(is_bare_repository)" = false ]; then
505 git read-tree -u -m HEAD || exit